#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#endif						

#include <stdio.h>
#include <tchar.h>


#include <Windows.h>

#include <iostream>
#include <string>

typedef unsigned int uint32;
typedef unsigned char uint8;

using namespace std;

string words[] = {
  "Es ist ",    
  "fnf ",
  "zehn ",
  "vor ",
  "nach ",
  "halb ",
  "drei",
  "viertel ",
  "vor ",
  "nach ",
  "um",
  "eins" ,
  "zwei ",
  "drei ",
  "vier ",
  "fnf ",
  "sechs ",
  "sieben ",
  "acht ",
  "neun ",
  "zehn ",
  "elf ",
  "zwlf ",
  "Uhr ",
  ".",
  ".",
  ".",
  "."
};

enum Positions{
  esist = 0,
  fuenfMin ,
  zehnMin ,
  vorMin ,
  nachMin ,
  halb ,
  dreiHour,
  viertel ,
  vorHour ,
  nachHour ,
  um,
  eins ,
  zwei ,
  drei ,
  vier ,
  fuenf ,
  sechs ,
  sieben ,
  acht ,
  neun ,
  zehn ,
  elf ,
  zwoelf ,
  Uhr ,
  min1,
  min2,
  min3,
  min4,
  
};

#define HOUR_Begin  eins
#define MIN_LEDS_begin  min1
#define WORDSCOUNT (min4+1)

uint32 getTimeLED(uint8 hour, uint8 minutes, bool wessimode)
{
  uint32 leds = (1<<esist);
  uint8 i = 0;
  if(hour>12)
    hour-=12;

  if(hour==0)
    hour = 12;


  uint8 minuteLeds = minutes%5;
  minutes = minutes/5 * 5;
  for(;minuteLeds;--minuteLeds){
    leds |= (1<< (minuteLeds-1 + MIN_LEDS_begin));
  }


  if(minutes<5){
    leds |= (1<<Uhr);
  }else if(minutes < 10){
    leds |= (1<<fuenfMin);
    leds |= (1<<nachMin);
  }else if(minutes < 15){
    leds |= (1<<zehnMin);
    leds |= (1<<nachMin);
  }else if(minutes < 20){
    leds |= (1<<viertel);
    if(wessimode){
      leds |= (1<<nachHour);
    }else{
      ++hour;
    }
  }else if(minutes < 25){
    leds |= (1<<zehnMin);
    leds |= (1<<vorMin);
    leds |= (1<<halb);
    ++hour;
  }else if(minutes < 30){
    leds |= (1<<fuenfMin);
    leds |= (1<<vorMin);
    leds |= (1<<halb);
    ++hour;
  }else if(minutes < 35){
    leds |= (1<<halb);
    ++hour;
  }else if(minutes < 40){
    leds |= (1<<fuenfMin);
    leds |= (1<<nachMin);
    leds |= (1<<halb);
    ++hour;
  }else if(minutes < 45){
    leds |= (1<<zehnMin);
    leds |= (1<<nachMin);
    leds |= (1<<halb);
    ++hour;
  }else if(minutes < 50){
    leds |= (1<<viertel);
    ++hour;
    if(wessimode){
      leds |= (1<<vorHour);
    }else{
      leds |= (1<<dreiHour);
    }
  }else if(minutes < 55){
    leds |= (1<<zehnMin);
    leds |= (1<<vorMin);
    ++hour;
  }else if(minutes < 60){
    leds |= (1<<fuenfMin);
    leds |= (1<<vorMin);
    ++hour;
  }


  if(hour>12)
    hour-=12;

  leds |= (1<< (HOUR_Begin + hour-1));

  return leds;

}

string decodeLEDtoString(uint32 leds)
{
  string ostr;
  for(uint8 i=0; i<32; ++i){
    if((leds & (1<<i)) && (i<WORDSCOUNT)){
      ostr += words[i];
    }
  }
  return ostr;
}

int _tmain(int argc, _TCHAR* argv[])
{

  uint8 hour=0;
  uint8 minutes=0;
  if(argc>2)
  {
    hour = atoi(argv[1]);
    minutes = atoi(argv[2]);
    cout << decodeLEDtoString(getTimeLED(hour, minutes, false))<<endl;
    cout << decodeLEDtoString(getTimeLED(hour, minutes, true))<<endl;

  }else{

    for(uint8 h=0;h<24;++h)
      for(uint8 m=0; m<60; ++m){
        cout << decodeLEDtoString(getTimeLED(h, m, false))<<endl;
      }

    cout<< endl<<endl;

    for(uint8 h=0;h<24;++h)
      for(uint8 m=0; m<60; ++m){
        cout << decodeLEDtoString(getTimeLED(h, m, true))<<endl;
      }
  }


	return 0;
}

